Imports System.Math

Public Class Form1
    Inherits System.Windows.Forms.Form

    ' Adapted from Link: http://www.vb-helper.com/howto_net_eyes.html

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents tmrLook As System.Windows.Forms.Timer
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.tmrLook = New System.Windows.Forms.Timer(Me.components)
        '
        'tmrLook
        '
        Me.tmrLook.Enabled = True
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.SystemColors.Control
        Me.ClientSize = New System.Drawing.Size(320, 232)
        Me.ControlBox = False
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "Form1"
        Me.TransparencyKey = System.Drawing.SystemColors.Control

    End Sub

#End Region

    ' The previous mouse location.
    Private m_MousePos As Point = New Point(-1, -1)

    ' The previously active application.
    Private m_ActiveApp As Application

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.SetStyle(ControlStyles.AllPaintingInWmPaint Or _
                    ControlStyles.ResizeRedraw Or _
                    ControlStyles.DoubleBuffer, _
                    True)
        Me.UpdateStyles()
    End Sub 'Form1_Load

    ' On left button, let the user drag the form.
    Private Sub Form1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        If e.Button = MouseButtons.Left Then
            Me.Capture = False

            ' Create and send a WM_NCLBUTTONDOWN message.
            Const WM_NCLBUTTONDOWN As Integer = &HA1S
            Const HTCAPTION As Integer = 2
            Dim msg As Message = Message.Create(Me.Handle, WM_NCLBUTTONDOWN, New IntPtr(HTCAPTION), IntPtr.Zero)
            Me.DefWndProc(msg)
        End If
    End Sub 'Form1_MouseDown

    ' On right button, exit.
    Private Sub Form1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseUp
        If e.Button = MouseButtons.Right Then Me.Close()
    End Sub 'Form1_MouseUp

    ' Force a redraw.
    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        m_MousePos = New Point(-1, -1)
        tmrLook_Tick(Nothing, Nothing)
    End Sub 'Form1_Resize

    ' See if the mouse has moved.
    Private Sub tmrLook_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrLook.Tick
        ' See if the cursor has moved.
        Dim new_pos As Point = Me.MousePosition()
        If new_pos.Equals(m_MousePos) Then Exit Sub
        m_MousePos = new_pos

        ' Redraw.
        Me.Invalidate()
    End Sub 'tmrLook_Tick

    ' Draw the eyes.
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        ' Convert the cursor position into form units.
        Dim local_pos As Point = Me.PointToClient(m_MousePos)

        ' Calculate the size of the eye.
        Dim hgt As Integer = CInt(Me.ClientSize.Height * 0.9)
        Dim wid As Integer = CInt(Me.ClientSize.Width * 0.45)

        ' Find the positions of the eyes.
        Dim y As Integer = (Me.ClientSize.Height - hgt) \ 2
        Dim x1 As Integer = CInt((Me.ClientSize.Width - wid * 2) / 3)
        Dim x2 As Integer = wid + 2 * x1

        e.Graphics.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias
        e.Graphics.Clear(Me.BackColor)

        ' Draw the eye.
        DrawEye(e.Graphics, local_pos, x1, y, wid, hgt)
        DrawEye(e.Graphics, local_pos, x2, y, wid, hgt)
    End Sub 'Form1_Paint

    ' Draw an eye here.
    Private Sub DrawEye(ByVal gr As Graphics, ByVal local_pos As Point, ByVal x1 As Integer, ByVal y1 As Integer, ByVal wid As Integer, ByVal hgt As Integer)
        ' Draw the outside.
        gr.FillEllipse(Brushes.White, x1, y1, wid, hgt)
        gr.DrawEllipse(Pens.Black, x1, y1, wid, hgt)

        ' Find the center of the eye.
        Dim cx As Integer = (x1 + wid \ 2)
        Dim cy As Integer = (y1 + hgt \ 2)

        ' Get the difference to the mouse position.
        Dim dx As Double = (local_pos.X - cx)
        Dim dy As Double = (local_pos.Y - cy)
        Dim dist As Double = Sqrt(dx * dx + dy * dy)
        dx /= dist
        dy /= dist

        ' This point is 1/4 of the way
        ' from the center to the edge of the eye.
        Dim px As Double = cx + dx * wid / 4
        Dim py As Double = cy + dy * hgt / 4

        ' Draw an ellipse 1/2 the size of the eye
        ' centered at (px, py).
        gr.FillEllipse(Brushes.Blue, CInt(px - wid / 4), CInt(py - hgt / 4), wid \ 2, hgt \ 2)
    End Sub 'DrawEye
End Class
