Public Class PopUp
    Inherits System.Windows.Forms.Form

    '********************************************************************
    '**                                                                **
    '** NOTE: Popup form StartPosition property MUST be set to Manual. **
    '**                                                                **
    '********************************************************************

    Public Sub New(ByVal location As String, _
                   ByVal parent As Form)
        MyClass.New()
        SetupValues(location, parent, Point.Empty, Size.Empty)
    End Sub 'New 

    Public Sub New(ByVal location As String, _
                   ByVal parent As Form, _
                   ByVal lastLocation As Point, _
                   ByVal lastSize As Size)
        MyClass.New()
        SetupValues(location, parent, lastLocation, lastSize)
    End Sub 'New

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents TextBox1 As System.Windows.Forms.TextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.TextBox1 = New System.Windows.Forms.TextBox
        Me.SuspendLayout()
        '
        'TextBox1
        '
        Me.TextBox1.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.TextBox1.Location = New System.Drawing.Point(8, 8)
        Me.TextBox1.Multiline = True
        Me.TextBox1.Name = "TextBox1"
        Me.TextBox1.Size = New System.Drawing.Size(272, 248)
        Me.TextBox1.TabIndex = 0
        Me.TextBox1.Text = ""
        '
        'PopUp
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 266)
        Me.Controls.Add(Me.TextBox1)
        Me.Name = "PopUp"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.Manual
        Me.Text = "PopUp"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub SetupValues(ByVal location As String, _
                            ByVal parent As Form, _
                            ByVal lastLocation As Point, _
                            ByVal lastSize As Size)
        Dim x, y, width, clientWidth, height, clientHeight, border, titleHeight As Integer
        With parent
            With .Location
                x = .X
                y = .Y
            End With
            With .ClientSize
                clientWidth = .Width
                clientHeight = .Height
            End With
            With .Size
                width = .Width
                height = .Height
            End With
            border = Math.Abs((width - clientWidth) \ 2)
            titleHeight = height - clientHeight - border
        End With
        Dim point As New Point(x, y)
        point.X += border
        point.Y += titleHeight
        Dim size As Size

        Me.StartPosition = FormStartPosition.Manual
        If lastLocation.Equals(point.Empty) Then
            Select Case location.Trim.ToLower
                Case "ul"
                    ' Do nothing
                Case "ml"
                    point.Y += ((clientHeight - Me.Height) \ 2)
                Case "ll"
                    point.Y += (clientHeight - Me.Height)
                Case "um"
                    point.X += ((clientWidth - Me.Width) \ 2)
                Case "mm"
                    point.X += ((clientWidth - Me.Width) \ 2)
                    point.Y += ((clientHeight - Me.Height) \ 2)
                Case "lm"
                    point.X += ((clientWidth - Me.Width) \ 2)
                    point.Y += (clientHeight - Me.Height)
                Case "ur"
                    point.X += (clientWidth - Me.Width)
                Case "mr"
                    point.X += (clientWidth - Me.Width)
                    point.Y += ((clientHeight - Me.Height) \ 2)
                Case "lr"
                    point.X += (clientWidth - Me.Width)
                    point.Y += (clientHeight - Me.Height)
            End Select
            size = New Size(300, 300)
        Else
            point = lastLocation
            size = lastSize
        End If
        Me.Location = point
        Me.Size = size
    End Sub 'SetupValues

End Class 'PopUp
